#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <stdio.h>
#define ll long long
#define ull unsigned long long

using namespace std;

int main()
{
    int tf, vf, hf, td, vd, hd;
    cin >> tf >> vf >> hf >> td >> vd >> hd;
    double gf = 1.0, gd = 3.0;

    double T1 = sqrt(2.0 * (double)(hf-hd) / gf);
    double T2 = (double)(vd * (tf - td)) / (double)(vf -vd);
    double T3 = sqrt(2.0 * hf / gf);

    double T = 0.0;
    if (T3 <= T2) {
        T = td + 2.0 * T3 * (double)vf / (double)vd;
    } else if (T2 >= T1) {
        T = (double)tf + T2 + T2 * (double)vf / (double)vd;
    } else {
        T = (double)tf + T1 + T1 * (double)vf / (double)vd;
    }

    double v0 = sqrt(2.0 * (double)hd * gd);
    double a = 0.5 - 0.5 * gd;
    double b = gd * (double)td - gd * (double)tf + v0;
    double c = v0 * (double)tf - v0 * (double)td - (double)hf - 0.5 * gd * (double)(td*td) + gd * (double)(td * tf) - 0.5 * gd * (double)(tf*tf);
    double disk = b * b - 4.0 * a * c;
    if (disk >= 0.0) {
        double t_1 = (-b + sqrt(disk)) / (2.0 * a);
        double t_2 = (-b - sqrt(disk)) / (2.0 * a);
        double T_1 = tf + t_1 + t_1 * vf / vd;
        double T_2 = tf + t_2 + t_2 * vf / vd;

        if (t_1 >= 0.0 && T_1 < T) {
            T = T_1;
        }
        if (t_2 >= 0.0 && T_2 < T) {
            T = T_2;
        }
    }

    //cout << T << endl;
    printf("%.6lf\n", T);

    return 0;
}
