#include <iostream>

using namespace std;

int polje[51][100001];
int XM = 51;
int YM = 100001;

void init_polje(){
    for(int x = 0; x < XM; x++){
        for(int y = 0; y < YM; y++){
            polje[x][y] = 0;
        }
    }
}

void hit(int x1, int y1, int x2, int y2){

    for (int x = x1; x <= x2; x++){
        for(int y = y1; y <= y2; y++){
            if(polje[x][y] != 0){
                polje[x][y] = 1;
            }
        }
    }

    int color = 0;
    while(color != 0) color = rand();
    flod_fill(x1, y1, color):
}

void flod_fill(int x, int y, int color){
    if(polje[x][y] == 0 && || x == 0 || y == 0 || x == XM || y == YM) return;

    polje[x][y] = color;

    flod_fill(x+1, y, color);
    flod_fill(x-1, y, color);
    flod_fill(x, y+1, color);
    flod_fill(x, y-1, color);
}

int query(int x1, int x2, int y1, int y2){
    if(polje[x1][y1] != 0 && polje[x1][y1] == polje[x2][y2]) return 1;
    else return 0;
}

int main()
{

    srand(4385954);
    init_polje();

    int L;
    cin >> L;

    int T;
    int q;
    int x1;
    int y1;
    int x2;
    int y2;

    for (int i = 0; i < L; i++){
        cin >> T;
        cin >> x1;
        cin >> y1;
        cin >> x2;
        cin >> y2;

        if(T == 0){
            hit(x1, y1, x2, x2);
        }else{
            q = query(x1, y1, x2, y2);
            cout << q << "\n";
        }
    }

    return 0;
}
